<?php

class VisitorController
{
    private VisitorModel $model;
    function __construct()
    {
        try {
            global $dsn, $rep, $vues, $error;
            $this->model = new VisitorModel();
            $action = $_REQUEST['action'];
            switch ($action) {
                case NULL:
                    $this->goToHome();
                    break;
                case "signUp":
                    $this->signUp();
                    break;
                case "login":
                    $this->login();
                    break;
                case "goToHome":
                    $this->goToHome();
                    break;
                case "goToLogin":
                    $this->goToLogin();
                    break;
                case "goToSignUp":
                    $this->goToSignUp();
                    break;
                case "goToQueue":
                    $this->goToLogin();
                    break;
                default:
                    $error = "Action non valide";
                    require($rep . $vues['erreur']);
                    break;
            }
        } catch (PDOException $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        } catch (Exception $e2) {
            $error = $e2->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function goToHome()
    {
        try {
            global $rep, $vues;
            require($rep . $vues['main']);
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function goToLogin()
    {
        try {
            global $rep, $vues;
            require($rep . $vues['login']);
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function goToSignUp()
    {
        try {
            global $rep, $vues;
            require($rep . $vues['signUp']);
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function signUp()
    {
        try {
            global $rep, $vues, $error;
            $this->model->signUp();
            $this->goToHome();
        } catch (PDOException $e) {
            $error = "Erreur de connexion à la base de données.";
            require($rep . $vues['erreur']);
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
    public function login()
    {
        try {
            global $rep, $vues, $error;
            $this->model->login();
            $this->goToHome();
        } catch (PDOException $e) {
            $error = "Erreur de connexion à la base de données.";
            require($rep . $vues['erreur']);
        } catch (Exception $e) {
            $error = $e->getMessage();
            require($rep . $vues['erreur']);
        }
    }
}